#ifndef defi_H
#define defi_H

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

#include "prova.h" // Debug flag

#ifdef __GNUC__
#include <sys/types.h>
#define _FASTCALL_
#else
#define _FASTCALL_ __fastcall
#endif

#undef  M_LN2
#define M_LN2	0.693147180559945309417
#undef  M_PI
#define M_PI	3.14159265358979323846
#define M_SQRT2	1.41421356237309504880

#undef max
#undef min
#define max(a,b) (((a) > (b)) ? (a) : (b))
#define min(x,y) (((x) > (y)) ? (y) : (x))

// Step for the test parameters
#define INCR(v,s) (((s)>0) ? ((v)+=(s)) : ((v)<<=-(s)))

typedef unsigned char UCHAR;
typedef unsigned long ULONG;
//typedef unsigned long long UI64;
typedef unsigned __int64 UI64;

extern char *buf;
extern ULONG *bits,n;

int _FASTCALL_ get_bit(const ULONG i,const ULONG *x);
void _FASTCALL_ set_bit(const ULONG i,const ULONG v,ULONG *const x);

extern ULONG bpos;
ULONG _FASTCALL_ rng(void);

void _FASTCALL_ SAVE(char *,double p);

double _FASTCALL_ KSnorm(double *data,const int n);
double _FASTCALL_ KStest(double *data,const int n);
double _FASTCALL_ ADtest(double *x, const int dim);
double _FASTCALL_ SLtest(double *pv,const int Np);
double igamc(double a,double x);
double lgam(double x);
double _FASTCALL_ chiQ(const double x,const int n);
double Phi(double x);
double _FASTCALL_ erfc(double x);
void _FASTCALL_ sort_pv(double *list, int n);

#endif
