/* ---------------------------------------------------------------------------
 Copyright (c) 2004, Cristiano, Italy.   All rights reserved.

 LICENSE TERMS

 The free distribution and use of this software in both source and binary
 form is allowed (with or without changes) provided that:

   1. distributions of this source code include the above copyright
      notice, this list of conditions and the following disclaimer;

   2. distributions in binary form include the above copyright
      notice, this list of conditions and the following disclaimer
      in the documentation and/or other associated materials;

   3. the copyright holder's name is not used to endorse products
      built using this software without specific written permission.

 ALTERNATIVELY, provided that this notice is retained in full, this product
 may be distributed under the terms of the GNU General Public License (GPL),
 in which case the provisions of the GPL apply INSTEAD OF those given above.

 DISCLAIMER

 This software is provided 'as is' with no explicit or implied warranties
 in respect of its properties, including, but not limited to, correctness
 and/or fitness for purpose.

 --------------------------------------------------------------------------- */

#include "defi.h"

void SOB(void)
{
	if(n<67108889) return; // 2^26 + 25 bits

	int s[256]={0}; // table for quick count-the-1's in a long stream
	ULONG w,i,j,q,m[32];

	m[31]=1; for (i=31; i>0; i--) m[i-1]=m[i]*2;

	// s[i] = number of 1 bits in i
	for(i=1; i<256; i++) {
		q=i; s[i]=1; while (q&=(q-1)) s[i]++;
	}

	ULONG *t=new ULONG[2097152]; for(i=0; i<2097152; i++) t[i]=0;

	// Initialize w with the firsts 25 bits
	w=0; for (i=0; i<25; i++) { w>>=1; if(get_bit(i,bits)) w += 1ul<<25; }

	for(i=0; i<67108864; i++) { // gets 2^26 w's, sets bit in t[] for each
		w>>=1; if(get_bit(i+25,bits)) w+=1ul<<25;
		j=w & 2097151; t[j] |= m[w>>21];
	}

	w=0;
	for(i=0; i<2097152; i++) { // loop to count 1's in t[] array
		j=t[i]; w+= s[j&255]+s[(j>>8)&255]+s[(j>>16)&255]+s[j>>24];
	}

	double z=(67108864-w-24687971.)/4170.; // convert counts to normal z-score
	SAVE("SOB",Phi(z)); delete[] t;
}
