/* ---------------------------------------------------------------------------
 Copyright (c) 2004, Cristiano, Italy.   All rights reserved.

 LICENSE TERMS

 The free distribution and use of this software in both source and binary
 form is allowed (with or without changes) provided that:

   1. distributions of this source code include the above copyright
      notice, this list of conditions and the following disclaimer;

   2. distributions in binary form include the above copyright
      notice, this list of conditions and the following disclaimer
      in the documentation and/or other associated materials;

   3. the copyright holder's name is not used to endorse products
      built using this software without specific written permission.

 ALTERNATIVELY, provided that this notice is retained in full, this product
 may be distributed under the terms of the GNU General Public License (GPL),
 in which case the provisions of the GPL apply INSTEAD OF those given above.

 DISCLAIMER

 This software is provided 'as is' with no explicit or implied warranties
 in respect of its properties, including, but not limited to, correctness
 and/or fitness for purpose.

 --------------------------------------------------------------------------- */

#include "defi.h"
#include <malloc.h>

extern int SERmin,SERmax,SERstp;

static double _FASTCALL_ psi2(const ULONG m)
{
  ULONG i,j,*P=(ULONG*)calloc( (1ul<< m+1)-1 ,sizeof(ULONG)); // zeroed

  for(i = 0; i < n-m; i++) { // COMPUTE FREQUENCY (avoid modulus)
     ULONG k = 1; for(j = 0; j < m; j++) k = 2*k+get_bit(i+j,bits);
     P[k-1]++;
  }

  for(i = n-m; i < n; i++) { // COMPUTE FREQUENCY
     ULONG k = 1; for(j = 0; j < m; j++) k = 2*k+get_bit((i+j)%n,bits);
     P[k-1]++;
  }

  double sum = 0; for(i =(1ul<<m)-1; i < (1ul<<m+1)-1; i++) sum +=double(P[i])*P[i];
  sum = sum*(1ul<<m)/(double)n - (double)n; free(P); return sum;
}

void SERIAL(void) // Serial 1_1 = Serial 1_2 = Short blk 1_1
{
	const int mmax=(int)(log((double)n)/M_LN2-2);

	for(int m=SERmin; m<=SERmax; INCR(m,SERstp)) {
		if(m>mmax) break; // m <= floor[log2(n)] -2
		
		double psim0, psim1, psim2, del1, del2;

		psim0 = psi2(m); psim1 = psi2(m-1); del1 = psim0 - psim1; 
		sprintf(buf,"Serial %d_1",m); SAVE(buf,chiQ(del1,1ul<<m-1));
		
		if(m!=1) { // Serial 1_1 = Serial 1_2
			psim2 = psi2(m-2); del2 = psim0 - 2.0*psim1 + psim2;
			sprintf(buf,"Serial %d_2",m); SAVE(buf,chiQ(del2,1ul<<m-2));
		}
	}
}
